# conda-configuration-8-4

Small tutorial with starting steps and templates for using **conda/mamba** on the servers (e841xx, e842xx, e844xx) of Fachbereich 8.4. This installation is inteded to replace personal installations of **conda** via the *Anaconda* distribution, which is no longer permitted at PTB.

---

If you are using *Windows*, you can find the "official" PTB **miniforge** installation in the *Softwarecenter*

---
On the compute servers, a central installation of both **conda** and **mamba** is provided. **mamba** is functionally identical to **conda**, it is just a faster reimplementation in *C++*, use whichever you prefer, the commands are identical.

The executables of both programs are located in the `/home/admin84/shared_public`, which should be configured on all servers the be included in `$PATH`. You can verify you are using the correct executable by running `conda info` (refer to the sample output below). If this returns a different location than above, please remove your personal previous installation of (ana)**conda** first. 

Uninstalling a personal installation of **anaconda** can be achieved by

0. Safety back up (see below)

1. Removing the **anaconda** folder (which is usually **not** your `$HOME/.conda` folder!), which contains the executables, package caches and configuration files, among other things. You can locate where the currently prioritised executable is at via `which conda`.

2. Removing custom channels from your `.condarc`, located usually either at `$HOME/.condarc` or `$HOME/.conda/.condarc` - you can just remove the *channels* key in the YAML file.

3. Checking which **conda** version is used by running `conda info`. This should return (at least) 

```
     active environment : None
       user config file : /home/<username/.condarc
 populated config files : /home/admin84/shared_public/miniforge3/.condarc
                          /home/<username>/.condarc
          conda version : 23.3.1
    conda-build version : not installed
         python version : 3.10.12.final.0
       virtual packages : __archspec=1=x86_64
                          __cuda=11.2=0
                          __glibc=2.31=0
                          __linux=5.4.0=0
                          __unix=0=0
       base environment : /home/admin84/shared_public/miniforge3  (read only)
      conda av data dir : /home/admin84/shared_public/miniforge3/etc/conda
  conda av metadata url : None
           channel URLs : https://conda.anaconda.org/conda-forge/linux-64
                          https://conda.anaconda.org/conda-forge/noarch
          
       envs directories : /miniforge3/envs
               platform : linux-64
             user-agent : conda/23.3.1 requests/2.31.0 CPython/3.10.12 Linux/5.4.0-144-generic ubuntu/20.04.6 glibc/2.31
                UID:GID : 10359:10359
             netrc file : None
           offline mode : False

```



## If you have used **conda** before

Please back up the composition of your environments using `conda env export --from-history` while the respective environments are activated. Using `--from-history` will only save the main packages you specifically requested, but not any dependencies installed during installing those packages. Packages which were installed using `pip` are also omitted. If you want to obtain a complete, unsanitised list, you can omit the `--from-history` flag.

---


Before using the 8.4 installation of conda you have to update your **bash** initialisation first by running

```
conda init --reverse # (only necessary if you previously used conda)
conda init
```

You can use the `.condarc` template provided here to customise the locations where your environments and package caches are located when using **conda**. The template includes the path where it should be saved. Please consider using the *san* for you paths to avoid cluttering the local drives. 

**conda** will be default use the *python* version which is installed on the host machine, but you can use any supported version when creating new environments, e.g. 

```
mamba create python=3.12 numpy ipython --name mamba-test
```
.
The default channel configured is [*conda-forge*](https://conda.anaconda.org/conda-forge/), which is still permitted by PTB. Please do not override this when creating new environments unless you are 100% certain that the licence of the channel in question permits use by PTB. When in doubt, please ask.

If any problems arise or you have further questions, please contact [me](mailto:oliver.henze@ptb.de) and I will amend this document with clarifications and answer questions.